VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsOS"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'
' Copyright (C) 2000-2004 Christian Lemke
'
' Bei Fragen oder Bugs (Fehlern) wenden sich sich bitte an:
'
'   E-Mail: support@chlhp.de
'      WWW: http://www.chlhp.de
'
'
'Update 18.01.2003:
'------------------
' + Windows 2003 Server wird jetzt auch erkannt
'
Option Explicit

' Windows Version herausfinden
Private Type OSVERSIONINFO
         dwOSVersionInfoSize As Long
         dwMajorVersion As Long
         dwMinorVersion As Long
         dwBuildNumber As Long
         dwPlatformId As Long
         szCSDVersion As String * 128
End Type
Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long

Public Enum osPlatform
    VER_PLATFORM_WIN32s = 0
    VER_PLATFORM_WIN32_WINDOWS = 1
    VER_PLATFORM_WIN32_NT = 2
End Enum

Private mOSminor As Long
Private mOSmajor As Long
Private mOSbuild As Long
Private mOSplatform As osPlatform
Private mOSinfo As String



Private Sub Class_Initialize()
On Error Resume Next
Dim WinVer As OSVERSIONINFO
Dim retval As Long

'Gre der Strucktur OSVERSIONINFO ermitteln
WinVer.dwOSVersionInfoSize = Len(WinVer)
'API-Aufruf, um Windowsversion auszulesen
retval = GetVersionEx(WinVer)
'Versionsnummer
mOSplatform = WinVer.dwPlatformId
mOSmajor = WinVer.dwMajorVersion
mOSminor = WinVer.dwMinorVersion
'Umwandlung der des Zahlenwerts fr Build
mOSbuild = WinVer.dwBuildNumber And &HFFFF&
'weitere Infos, z.B. ber Service Packs
mOSinfo = TrimNull(WinVer.szCSDVersion)
'bei Windows 98 SE, die Infos ndern
If mOSplatform = VER_PLATFORM_WIN32_WINDOWS Then
    If mOSmajor = 4 And mOSminor = 10 Then
        If mOSbuild = 2222 Then mOSinfo = "SE"
    End If
End If
End Sub


Private Function TrimNull(ByVal str As String) As String
On Error Resume Next

TrimNull = Trim$(Left$(str, InStr(str, Chr$(0)) - 1))
End Function


Public Function getPlatformName(ByVal major As Long, ByVal minor As Long, ByVal build As Long, ByVal platform As osPlatform) As String
On Error Resume Next

Select Case platform
    Case VER_PLATFORM_WIN32s
        getPlatformName = "Win32s (32-bit Emulation fr 16-bit Windows)"
    Case VER_PLATFORM_WIN32_WINDOWS
        If minor = 0 Then
            getPlatformName = "Windows 95"
        ElseIf minor = 10 Then
            getPlatformName = "Windows 98"
        Else
            getPlatformName = "Windows ME"
        End If
    Case VER_PLATFORM_WIN32_NT
        If major = 4 Then
            getPlatformName = "Windows NT"
         ElseIf major = 5 Then
            If minor = 0 Then
                getPlatformName = "Windows 2000"
             ElseIf minor = 1 Then
                getPlatformName = "Windows XP"
             ElseIf minor = 2 Then
                getPlatformName = "Windows 2003 Server"
            End If
        End If
End Select
If Len(getPlatformName) = 0 Then getPlatformName = "(unbekannt)"
End Function


Public Property Get PlatformName() As String
On Error Resume Next

PlatformName = getPlatformName(mOSmajor, mOSminor, mOSbuild, mOSplatform)
End Property


Public Property Get VersionMajor() As String
On Error Resume Next

VersionMajor = mOSmajor
End Property


Public Property Get VersionMinor() As String
On Error Resume Next

VersionMinor = mOSminor
End Property


Public Property Get VersionBuild() As String
On Error Resume Next

VersionBuild = mOSbuild
End Property


Public Property Get VersionInfo() As String
On Error Resume Next

VersionInfo = mOSinfo
End Property


Public Property Get VersionPlatformID() As osPlatform
On Error Resume Next

VersionPlatformID = mOSplatform
End Property

